package org.aleabodo.fireworksmc.Commands;

import org.aleabodo.fireworksmc.Fireworks_Mc;
import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Firework;
import org.bukkit.entity.Player;
import org.bukkit.inventory.meta.FireworkMeta;
import org.bukkit.scheduler.BukkitRunnable;
import org.jetbrains.annotations.NotNull;

public class SpawnRocket implements CommandExecutor {
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (!(sender instanceof Player)) {
            sender.sendMessage("This command is reserved for players only!");
            return false;
        }

        Player player = ((Player) sender).getPlayer();

        this.spawnRocket(player.getLocation());

        return true;
    }

    private void spawnRocket(Location location) {
        Firework firework = (Firework) location.getWorld().spawnEntity(location, EntityType.FIREWORK);
        FireworkMeta fireworkMeta = firework.getFireworkMeta();

        // Create a firework effect
        FireworkEffect effect = FireworkEffect.builder()
                .flicker(true)
                .trail(true)
                .withColor(Color.RED)
                .withFade(Color.YELLOW)
                .with(FireworkEffect.Type.BALL_LARGE)
                .build();

        fireworkMeta.addEffect(effect);
        fireworkMeta.setPower(10); // Number of times the firework will explode
        firework.setFireworkMeta(fireworkMeta);

        // Schedule the firework to be removed after a delay
        new BukkitRunnable() {
            @Override
            public void run() {
                firework.detonate();
            }
        }.runTaskLater(Fireworks_Mc.getPlugin(), 60); // 20 ticks = 1 second
    }
}
